Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.caucho.xml
Class QAbstractNode

    java.lang.Object
      |
      +--com.caucho.xml.QAbstractNode

All Implemented Interfaces:
  CauchoNode, Node

Direct Known Subclasses:
  QNode

public abstract class QAbstractNode
extends java.lang.Object
implements CauchoNode

QAbstractNode is an abstract implementation for any DOM node.

Field Summary
`protected static L10N` | `L`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`QAbstractNode()`

Method Summary
`Node` | `appendChild(Node newNode)` Adds the node `newChild` to the end of the list of children of this node.
`boolean` | `checkValid()` For testing...
`Node` | `cloneNode(boolean deep)` Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
`boolean` | `equals(Node arg, boolean deep)`
`NamedNodeMap` | `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
`java.lang.String` | `getCanonicalName()` Returns the node's canonical name.
`NodeList` | `getChildNodes()` A `NodeList` that contains all children of this node.
`int` | `getColumn()` Returns the source column of this node.
`java.lang.String` | `getFilename()` Returns the node's source filename.
`Node` | `getFirstChild()` The first child of this node.
`Node` | `getLastChild()` The last child of this node.
`int` | `getLine()` Returns the node's source line.
`java.lang.String` | `getLocalName()` Returns the local part of the qualified name of this node.
`java.lang.String` | `getNamespaceURI()` The namespace URI of this node, or `null` if it is unspecified.
`QAbstractNode` | `getNextContent()`
`QAbstractNode` | `getNextPreorder()`
`Node` | `getNextSibling()` The node immediately following this node.
`java.lang.String` | `getNodeValue()` The value of this node, depending on its type; see the table above.
`Document` | `getOwnerDocument()` Returns the owning document.
`Node` | `getParentNode()` The parent of this node.
`java.lang.String` | `getPrefix()` The namespace prefix of this node, or `null` if it is unspecified.
`QAbstractNode` | `getPreviousContent()`
`Node` | `getPreviousSibling()` The node immediately preceding this node.
`java.lang.String` | `getTextValue()` Returns the text value of the node
`boolean` | `hasAttributes()` Returns true if the node has attributes.
`boolean` | `hasChildNodes()` Returns whether this node has any children.
`boolean` | `hasContent()`
`Node` | `insertBefore(Node newChild, Node refChild)` Inserts the node `newChild` before the existing child node `refChild`.
`boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.
`void` | `normalize()` Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
`void` | `print(WriteStream out)` Prints the node to a stream
`void` | `printHtml(WriteStream out)` Prints the node as html to a stream
`void` | `printPretty(WriteStream out)` Pretty-prints the node to a stream
`Node` | `removeChild(Node oldChild)` Removes the child node indicated by `oldChild` from the list of children, and returns it.
`Node` | `replaceChild(Node newChild, Node refChild)` Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
`void` | `setLocation(java.lang.String filename, int line, int column)` Sets the location
`void` | `setNodeValue(java.lang.String value)` The value of this node, depending on its type; see the table above.
`void` | `setPrefix(java.lang.String prefix)` The namespace prefix of this node, or `null` if it is unspecified.
`boolean` | `supports(java.lang.String feature, java.lang.String version)` Support the same and the implementation

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Node
`getNodeName, getNodeType`

Field Detail

### L

    protected static L10N L

Constructor Detail

### QAbstractNode

    public QAbstractNode()

Method Detail

### setLocation

    public void setLocation(java.lang.String filename,
                            int line,
                            int column)

  Description copied from interface: `CauchoNode`
  Sets the location
  Specified by:
    `setLocation` in interface `CauchoNode`

### getFilename

    public java.lang.String getFilename()

  Returns the node's source filename.
  Specified by:
    `getFilename` in interface `CauchoNode`

### getLine

    public int getLine()

  Returns the node's source line.
  Specified by:
    `getLine` in interface `CauchoNode`

### getColumn

    public int getColumn()

  Description copied from interface: `CauchoNode`
  Returns the source column of this node.
  Specified by:
    `getColumn` in interface `CauchoNode`

### getOwnerDocument

    public Document getOwnerDocument()

  Returns the owning document.
  Specified by:
    `getOwnerDocument` in interface `Node`

### isSupported

    public boolean isSupported(java.lang.String feature,
                               java.lang.String version)

  Description copied from interface: `Node`
  Tests whether the DOM implementation implements a specific feature and that feature is supported by this node.
  Specified by:
    `isSupported` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Parameters:
    `feature` - The name of the feature to test. This is the same name which can be passed to the method `hasFeature` on `DOMImplementation`.
    `version` - This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.
  Returns:
    Returns `true` if the specified feature is supported on this node, `false` otherwise.

### hasAttributes

    public boolean hasAttributes()

  Returns true if the node has attributes.
  Specified by:
    `hasAttributes` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Returns:
    `true` if this node has any attributes, `false` otherwise.

### getPrefix

    public java.lang.String getPrefix()

  Description copied from interface: `Node`
  The namespace prefix of this node, or `null` if it is unspecified.
  Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
  Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.
  Specified by:
    `getPrefix` in interface `CauchoNode`
  Following copied from interface: `org.w3c.dom.Node`
  Throws:
    `DOMException` - INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character, per the XML 1.0 specification .
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NAMESPACE_ERR: Raised if the specified `prefix` is malformed per the Namespaces in XML specification, if the `namespaceURI` of this node is `null`, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the `namespaceURI` of this node is different from " http://www.w3.org/2000/xmlns/", or if this node is an attribute and the `qualifiedName` of this node is "xmlns" .

### setPrefix

    public void setPrefix(java.lang.String prefix)

  Description copied from interface: `Node`
  The namespace prefix of this node, or `null` if it is unspecified.
  Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
  Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.
  Specified by:
    `setPrefix` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Throws:
    `DOMException` - INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character, per the XML 1.0 specification .
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NAMESPACE_ERR: Raised if the specified `prefix` is malformed per the Namespaces in XML specification, if the `namespaceURI` of this node is `null`, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the `namespaceURI` of this node is different from " http://www.w3.org/2000/xmlns/", or if this node is an attribute and the `qualifiedName` of this node is "xmlns" .

### getCanonicalName

    public java.lang.String getCanonicalName()

  Description copied from interface: `CauchoNode`
  Returns the node's canonical name.

  e.g. for foo:bar:baz, the prefix name might be '{/caucho/1.0}baz'

  Specified by:
    `getCanonicalName` in interface `CauchoNode`

### getLocalName

    public java.lang.String getLocalName()

  Description copied from interface: `Node`
  Returns the local part of the qualified name of this node.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.
  Specified by:
    `getLocalName` in interface `CauchoNode`

### getNamespaceURI

    public java.lang.String getNamespaceURI()

  Description copied from interface: `Node`
  The namespace URI of this node, or `null` if it is unspecified.
  This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.
  For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.Per the Namespaces in XML Specification an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it simply has no namespace.
  Specified by:
    `getNamespaceURI` in interface `CauchoNode`

### getNodeValue

    public java.lang.String getNodeValue()

  Description copied from interface: `Node`
  The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect.
  Specified by:
    `getNodeValue` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### setNodeValue

    public void setNodeValue(java.lang.String value)

  Description copied from interface: `Node`
  The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect.
  Specified by:
    `setNodeValue` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### getParentNode

    public Node getParentNode()

  Description copied from interface: `Node`
  The parent of this node. All nodes, except `Attr`, `Document`, `DocumentFragment`, `Entity`, and `Notation` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is `null`.
  Specified by:
    `getParentNode` in interface `Node`

### getChildNodes

    public NodeList getChildNodes()

  Description copied from interface: `Node`
  A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes.
  Specified by:
    `getChildNodes` in interface `Node`

### getFirstChild

    public Node getFirstChild()

  Description copied from interface: `Node`
  The first child of this node. If there is no such node, this returns `null`.
  Specified by:
    `getFirstChild` in interface `Node`

### getLastChild

    public Node getLastChild()

  Description copied from interface: `Node`
  The last child of this node. If there is no such node, this returns `null`.
  Specified by:
    `getLastChild` in interface `Node`

### getPreviousSibling

    public Node getPreviousSibling()

  Description copied from interface: `Node`
  The node immediately preceding this node. If there is no such node, this returns `null`.
  Specified by:
    `getPreviousSibling` in interface `Node`

### getNextSibling

    public Node getNextSibling()

  Description copied from interface: `Node`
  The node immediately following this node. If there is no such node, this returns `null`.
  Specified by:
    `getNextSibling` in interface `Node`

### getAttributes

    public NamedNodeMap getAttributes()

  Description copied from interface: `Node`
  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
  Specified by:
    `getAttributes` in interface `Node`

### insertBefore

    public Node insertBefore(Node newChild,
                             Node refChild)
                      throws DOMException

  Description copied from interface: `Node`
  Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children.
  If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed.
  Specified by:
    `insertBefore` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Parameters:
    `newChild` - The node to insert.
    `refChild` - The reference node, i.e., the node before which the new node must be inserted.
  Returns:
    The node being inserted.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors or this node itself.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the parent of the node being inserted is readonly.
    NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.

### replaceChild

    public Node replaceChild(Node newChild,
                             Node refChild)
                      throws DOMException

  Description copied from interface: `Node`
  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
  If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed.
  Specified by:
    `replaceChild` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Parameters:
    `newChild` - The new node to put in the child list.
    `oldChild` - The node being replaced in the list.
  Returns:
    The node replaced.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to put in is one of this node's ancestors or this node itself.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the parent of the new node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

### removeChild

    public Node removeChild(Node oldChild)
                     throws DOMException

  Description copied from interface: `Node`
  Removes the child node indicated by `oldChild` from the list of children, and returns it.
  Specified by:
    `removeChild` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Parameters:
    `oldChild` - The node being removed.
  Returns:
    The node removed.
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

### appendChild

    public Node appendChild(Node newNode)
                     throws DOMException

  Description copied from interface: `Node`
  Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed.
  Specified by:
    `appendChild` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Parameters:
    `newChild` - The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
  Returns:
    The node added.
  Throws:
    `DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to append is one of this node's ancestors or this node itself.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the previous parent of the node being inserted is readonly.

### hasChildNodes

    public boolean hasChildNodes()

  Description copied from interface: `Node`
  Returns whether this node has any children.
  Specified by:
    `hasChildNodes` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Returns:
    `true` if this node has any children, `false` otherwise.

### equals

    public boolean equals(Node arg,
                          boolean deep)

### getNextPreorder

    public QAbstractNode getNextPreorder()

### hasContent

    public boolean hasContent()

### getNextContent

    public QAbstractNode getNextContent()

### getPreviousContent

    public QAbstractNode getPreviousContent()

### getTextValue

    public java.lang.String getTextValue()

  Description copied from interface: `CauchoNode`
  Returns the text value of the node
  Specified by:
    `getTextValue` in interface `CauchoNode`

### supports

    public boolean supports(java.lang.String feature,
                            java.lang.String version)

  Support the same and the implementation

### normalize

    public void normalize()

  Description copied from interface: `Node`
  Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used.In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes.
  Specified by:
    `normalize` in interface `Node`

### cloneNode

    public Node cloneNode(boolean deep)

  Description copied from interface: `Node`
  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent; ( `parentNode` is `null`.).
  Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning an `Attribute` directly, as opposed to be cloned as part of an `Element` cloning operation, returns a specified attribute ( `specified` is `true`). Cloning any other type of node simply returns a copy of this node.
  Note that cloning an immutable subtree results in a mutable copy, but the children of an `EntityReference` clone are readonly . In addition, clones of unspecified `Attr` nodes are specified. And, cloning `Document`, `DocumentType`, `Entity`, and `Notation` nodes is implementation dependent.
  Specified by:
    `cloneNode` in interface `Node`
  Following copied from interface: `org.w3c.dom.Node`
  Parameters:
    `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
  Returns:
    The duplicate node.

### checkValid

    public boolean checkValid()
                       throws java.lang.Exception

  Description copied from interface: `CauchoNode`
  For testing...
  Specified by:
    `checkValid` in interface `CauchoNode`

### print

    public void print(WriteStream out)
               throws java.io.IOException

  Description copied from interface: `CauchoNode`
  Prints the node to a stream
  Specified by:
    `print` in interface `CauchoNode`

### printPretty

    public void printPretty(WriteStream out)
                     throws java.io.IOException

  Description copied from interface: `CauchoNode`
  Pretty-prints the node to a stream
  Specified by:
    `printPretty` in interface `CauchoNode`

### printHtml

    public void printHtml(WriteStream out)
                   throws java.io.IOException

  Description copied from interface: `CauchoNode`
  Prints the node as html to a stream
  Specified by:
    `printHtml` in interface `CauchoNode`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD